import { Action, ActionFunctionAny } from 'redux-actions';
import { AsyncBaseActionControl, Selector } from './types';
export default class AsyncActionControl {
    label: string;
    rawKey: string;
    start: ActionFunctionAny<Action<any>>;
    success: ActionFunctionAny<Action<any>>;
    failure: ActionFunctionAny<Action<any>>;
    cancel: ActionFunctionAny<Action<any>>;
    getKey(actionId?: string | number): string;
    getStateValue(state: any, actionId?: string | number): string;
    isRunning(actionId?: string | number): Selector;
    isCancelled(actionId?: string | number): Selector;
    hasFailure(actionId?: string | number): Selector;
    isSuccessful(actionId?: string | number): Selector;
    constructor(label: string, rawKey: string, stateActions: AsyncBaseActionControl);
}
