"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AwaitControl_1 = require("./AwaitControl");
class AsyncActionControl {
    constructor(label, rawKey, stateActions) {
        this.label = label;
        this.rawKey = rawKey;
        this.start = stateActions.start;
        this.success = stateActions.success;
        this.failure = stateActions.failure;
        this.cancel = stateActions.cancel;
    }
    getKey(actionId) {
        if (actionId) {
            return `${this.rawKey}_${actionId.toString().toUpperCase()}`;
        }
        return this.rawKey;
    }
    getStateValue(state, actionId) {
        return state[AwaitControl_1.default.getControl().keyReducer][this.getKey(actionId)];
    }
    isRunning(actionId) {
        return (state) => this.getStateValue(state, actionId) === 'START';
    }
    isCancelled(actionId) {
        return (state) => this.getStateValue(state, actionId) === 'CANCEL';
    }
    hasFailure(actionId) {
        return (state) => this.getStateValue(state, actionId) === 'FAILURE';
    }
    isSuccessful(actionId) {
        return (state) => this.getStateValue(state, actionId) === 'SUCCESS';
    }
}
exports.default = AsyncActionControl;
