"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const redux_actions_1 = require("redux-actions");
const AsyncActionControl_1 = require("./AsyncActionControl");
const utils_1 = require("./utils");
const constants_1 = require("./constants");
function createAsyncAction(actionName, prefix = constants_1.PREFIX) {
    const asyncActionsMapper = {};
    const asyncLabelsMapper = {};
    constants_1.STATUS_LIST.forEach((status) => {
        const fetchActionName = `${actionName}_${status}`;
        asyncLabelsMapper[status] = { label: utils_1.camelCase(fetchActionName) };
        asyncActionsMapper[fetchActionName] = [
            (payload) => payload,
            (payload, meta) => meta,
        ];
    });
    const { [asyncLabelsMapper[constants_1.START].label]: start, [asyncLabelsMapper[constants_1.SUCCESS].label]: success, [asyncLabelsMapper[constants_1.FAILURE].label]: failure, [asyncLabelsMapper[constants_1.CANCEL].label]: cancel, } = redux_actions_1.createActions(asyncActionsMapper, { prefix: prefix || constants_1.PREFIX });
    const actionLabel = `${prefix || constants_1.PREFIX}/${actionName}`;
    return new AsyncActionControl_1.default(actionLabel, actionName, {
        start,
        success,
        failure,
        cancel,
    });
}
exports.default = createAsyncAction;
