"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const formatRequestName = (requestName, { payload, meta }) => {
    const actionPayloadMeta = {};
    if (typeof payload === 'object') {
        Object.assign(actionPayloadMeta, payload);
    }
    if (typeof meta === 'object') {
        Object.assign(actionPayloadMeta, meta);
    }
    if (actionPayloadMeta.actionId) {
        return `${requestName}_${actionPayloadMeta.actionId.toString().toUpperCase()}`;
    }
    return requestName;
};
function reducer(state = {}, action) {
    const matches = /(.*)\/(.*)_(START|SUCCESS|FAILURE|CANCEL)/.exec(action.type);
    if (!matches)
        return state;
    const [, , requestName, requestState] = matches;
    const formattedRequestName = formatRequestName(requestName, action);
    if (state[formattedRequestName] === constants_1.START && [constants_1.SUCCESS, constants_1.FAILURE, constants_1.CANCEL].includes(requestState)) {
        return Object.assign(Object.assign({}, state), { [formattedRequestName]: requestState });
    }
    if (requestState === constants_1.START) {
        return Object.assign(Object.assign({}, state), { [formattedRequestName]: constants_1.START });
    }
    return state;
}
exports.default = reducer;
